/**
 * JASMINe
 * Copyright (C) 2009-2011 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: RuleEngineService.java 8807 2011-09-06 14:34:57Z diorcety $
 * --------------------------------------------------------------------------
 */

package org.ow2.jasmine.monitoring.eos.rules.common;

import org.ow2.jasmine.rules.manager.model.IRulePackage;
import org.ow2.jasmine.rules.manager.service.RulePackageCompilationError;
import org.ow2.jasmine.rules.manager.service.RulePackageSaveReport;
import org.w3c.dom.Document;

import java.util.List;

public interface RuleEngineService {
    void start(String ruleEngineName) throws Exception;

    void stop(String ruleEngineName) throws Exception;

    RuleEngineStatus getRuleEngineStatus(String ruleEngineName) throws Exception;

    List<IRulePackage> getRulePackages(String ruleEngineName) throws Exception;

    IRulePackage getRulePackage(String rulePackageSystemName, String ruleEngineName) throws Exception;

    RulePackageSaveReport saveRulePackage(IRulePackage rulePackage, String ruleEngineName) throws Exception;

    void deleteRulePackage(IRulePackage rulePackage, String ruleEngineName) throws Exception;

    List<RulePackageCompilationError> compileRulePackage(IRulePackage rulePackage, String ruleEngineName) throws Exception;

    Boolean checkNameAvailability(String systemName, String ruleEngineName) throws Exception;

    Document exportRulePackagesAsXML(List<IRulePackage> rulePackages, String ruleEngineName) throws Exception;

    IRulePackage importRulePackageFromXML(String filePath, String ruleEngineName) throws Exception;
}
